%global base_version 1.59
Name:           perl-threads-shared
Version:        1.62
Release:        2
Summary:        Perl extension for sharing data structures between threads
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/threads-shared
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/threads-shared-%{base_version}.tar.gz
BuildRequires:  perl-generators perl-interpreter perl-devel gcc perl(threads) >= 1.73
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76 perl(ExtUtils::testlib) perl(Test::More)
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       perl(Carp)
Requires:       perl(threads) >= 1.73
Requires:       perl(XSLoader)

Patch0:         threads-shared-1.59-Upgrade-to-1.60.patch
Patch1:         threads-shared-1.60-threads-shared-fix-leak.patch
Patch2:         threads-shared-1.59-Upgrade-to-1.61.patch
Patch3:         threads-shared-1.61-Upgrade-to-1.62.patch

%description
By default, variables are private to each thread, and each newly created
thread gets a private copy of each existing variable. This module allows
you to share variables across different threads (and pseudo-forks on
Win32). It is used together with the threads module.

This module supports the sharing of the following data types only: scalars
and scalar refs, arrays and array refs, and hashes and hash refs.

%package_help

%prep
%autosetup -n threads-shared-%{base_version} -p1

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 OPTIMIZE="$RPM_OPT_FLAGS"
%make_build

%install
make pure_install DESTDIR=%{buildroot}
%{_fixperms} %{buildroot}/*

%check
make test

%files
%doc README
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/threads*

%files help
%doc Changes examples
%{_mandir}/man3/*

%changelog
* Tue Oct 25 2022 jiangchuangang <jiangchuangang@huawei.com> - 1.62-2
- use macros package_help

* Fri Dec 31 2021 yuanxin <yuanxin24@huawei.com> - 1.62-1
- update version to 1.62

* Wed Jun 23 2021 wuchaochao <wuchaochao4@huawei.com> - 1.59-4
- add buildrequires: gcc

* Wed May 13 2020 licunlong <licunlong1@huawei.com> - 1.59-3
- add perl-devel buildrequire

* Fri Sep 27 2019 luhuaxin <luhuaxin@huawei.com> - 1.59-2
- Type: enhancement
- ID: NA
- SUG: NA
- DESC: move README file to main package

* Wed Sep 11 2019 luhuaxin <luhuaxin@huawei.com> - 1.59-1
- Package init
